/// <reference types="node" />
import fs from "fs-extra";
import { Readable } from "stream";
export declare type TreeNodeId = string | number | null;
interface TreeNode {
    id: TreeNodeId;
    parentId: TreeNodeId;
    children: TreeNode[];
    data: any;
}
export interface Config {
    keys: Partial<{
        id: string;
        parentId: string;
        children: string;
        data: string;
    }>;
    tab: Partial<{
        insertSpaces: boolean;
        size: number;
        autoDetect: boolean;
    }>;
    getId: (data: any) => TreeNodeId;
}
export declare const parseStream: (stream: Readable | fs.ReadStream, config?: Partial<Config>) => Promise<TreeNode[]>;
export declare const parseFile: (filePath: string, config?: Partial<Config>) => Promise<TreeNode[]>;
export declare const parseString: (str: string, config?: Partial<Config>) => Promise<TreeNode[]>;
export {};
